summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <meyering@fb.com>2016-05-30 17:07:52 -0700
committerJim Meyering <meyering@fb.com>2016-06-01 21:13:05 -0700
commit5fac9a39d45e761f2b27262c4fd13ccb3ff8dc9b (patch)
treec6a0b9a422061e024a010ded2a9f036696f93210
parent455bad28ec7120640750ecfca12ddacce27d5fe8 (diff)
downloadautomake-5fac9a39d45e761f2b27262c4fd13ccb3ff8dc9b.tar.gz
compile: remove .Tpo file upon failure
When generating a .deps/base.Po file, our emitted rule first writes to a temporary .Tpo file, so the final creation can be atomic, via mv's rename. However, when generation of the .Tpo fails, it stop the process and does not remove that temporary file. And nothing else ever deletes it, either. Hence, in the unusual case in which one expects a compilation to fail during a successful build (gnulib's test-verify.sh does precisely this), a .deps/test-verify.Tpo file would be left behind, and that would in turn cause a "make distcheck" failure because that file would exist in one build+distclean hierarchy but not in the distribution tarball. * lib/am/depend2.am: Ensure that the temporary file is removed upon failure. * t/distcheck-Tpo.sh: New file. * t/list-of-tests.mk (handwritten_TESTS): Add it. This addresses bug#23661.
-rw-r--r--lib/am/depend2.am10
-rw-r--r--t/distcheck-Tpo.sh58
-rw-r--r--t/list-of-tests.mk1
3 files changed, 65 insertions, 4 deletions
diff --git a/lib/am/depend2.am b/lib/am/depend2.am
index 87f62a80d..d1478b916 100644
--- a/lib/am/depend2.am
+++ b/lib/am/depend2.am
@@ -42,8 +42,9 @@ if %?NONLIBTOOL%
?!GENERIC?%OBJ%: %SOURCE%
if %FASTDEP%
%VERBOSE%$(am__set_depbase) && \
- %COMPILE% -MT $@ -MD -MP -MF $$depbase.Tpo -c -o $@ %SOURCEFLAG% %XSOURCE% && \
- $(am__mv) $$depbase.Tpo $$depbase.Po
+ %COMPILE% -MT $@ -MD -MP -MF $$depbase.Tpo -c -o $@ %SOURCEFLAG% %XSOURCE%; \
+ if test $$? = 0; then $(am__mv) $$depbase.Tpo $$depbase.Po; \
+ else rm -f $$depbase.Tpo; false; fi
else !%FASTDEP%
if %AMDEP%
%VERBOSE%source='%SOURCE%' object='$@' libtool=no @AMDEPBACKSLASH@
@@ -56,8 +57,9 @@ endif !%FASTDEP%
?!GENERIC?%OBJOBJ%: %SOURCE%
if %FASTDEP%
%VERBOSE%$(am__set_depbase) && \
- %COMPILE% -MT $@ -MD -MP -MF $$depbase.Tpo -c -o $@ %SOURCEFLAG% $$($(CYGPATH_W) %XSOURCE%) && \
- $(am__mv) $$depbase.Tpo $$depbase.Po
+ %COMPILE% -MT $@ -MD -MP -MF $$depbase.Tpo -c -o $@ %SOURCEFLAG% $$($(CYGPATH_W) %XSOURCE%); \
+ if test $$? = 0; then $(am__mv) $$depbase.Tpo $$depbase.Po; \
+ else rm -f $$depbase.Tpo; false; fi
else !%FASTDEP%
if %AMDEP%
%VERBOSE%source='%SOURCE%' object='$@' libtool=no @AMDEPBACKSLASH@
diff --git a/t/distcheck-Tpo.sh b/t/distcheck-Tpo.sh
new file mode 100644
index 000000000..9d7900cb4
--- /dev/null
+++ b/t/distcheck-Tpo.sh
@@ -0,0 +1,58 @@
+#! /bin/sh
+# Copyright (C) 2016 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Ensure that the 'make distcheck'-run distcleancheck does not fail
+# due to a leftover .deps/base.Tpo file when part of a successful build
+# involves a failed attempt to create a .deps/base.Po file.
+
+. test-init.sh
+
+cat >> configure.ac <<END
+AC_PROG_CC
+AC_OUTPUT
+END
+
+cat > foo.c <<\END
+#ifndef FAIL
+int main() { return 0; }
+#else
+int x[no_such];
+#endif
+END
+
+cat > Makefile.am <<\END
+TESTS = foo bar.test
+check_PROGRAMS = foo
+EXTRA_DIST= bar.test foo.c
+END
+
+cat > bar.test <<END
+#!/bin/sh
+rm -f foo.o
+$MAKE AM_CFLAGS=-DFAIL foo.o && exit 1
+exit 0
+END
+chmod a+x bar.test
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+./configure
+
+# We can build the distribution.
+run_make -M distcheck
+
+:
diff --git a/t/list-of-tests.mk b/t/list-of-tests.mk
index f1c47bb53..060b3ed1c 100644
--- a/t/list-of-tests.mk
+++ b/t/list-of-tests.mk
@@ -433,6 +433,7 @@ t/distcheck-override-infodir.sh \
t/distcheck-pr9579.sh \
t/distcheck-pr10470.sh \
t/distcheck-pr18286.sh \
+t/distcheck-Tpo.sh \
t/dmalloc.sh \
t/doc-parsing-buglets-colneq-subst.sh \
t/doc-parsing-buglets-tabs.sh \